import { world, ItemCooldownComponent } from '@minecraft/server';
import { useTypes, commandSubject } from '../Interfaces/on_Use_Interfaces';

world.afterEvents.itemCompleteUse.subscribe((data) => {
    console.warn(`Item completo usado: ${data.itemStack.typeId}`);

    // Verifica se o item consumido é uma poção específica
    if (data.itemStack.typeId === "well:pocao_gigante") {
        // Executa comandos no jogador
        data.source.runCommand("event entity @s gigante");
        data.source.runCommand("scoreboard players set @s camera_rpg 5");
    }
});
world.afterEvents.itemCompleteUse.subscribe((data) => {
    console.warn(`Item completo usado: ${data.itemStack.typeId}`);

    // Verifica se o item consumido é uma poção específica
    if (data.itemStack.typeId === "well:pocao_pequeno") {
        // Executa comandos no jogador
        data.source.runCommand("event entity @s pequeno");
        data.source.runCommand("scoreboard players set @s camera_rpg 4");
    }
});

world.afterEvents.itemCompleteUse.subscribe((data) => {
    console.warn(`Item completo usado: ${data.itemStack.typeId}`);

    // Verifica se o item consumido é uma poção específica
    if (data.itemStack.typeId === "well:pocao_desvanecimento") {
        // Executa comandos no jogador
        data.source.runCommand("event entity @s add_desvanecimento");
        data.source.runCommand("titleraw @s title {\"rawtext\":[{\"translate\":\"dialogue.desvanecimento\"}]}");
    }
});


world.afterEvents.itemCompleteUse.subscribe((data) => {
    console.warn(`Item completo usado: ${data.itemStack.typeId}`);

    // Verifica se o item consumido é uma poção específica
    if (data.itemStack.typeId === "minecraft:milk_bucket") {
        // Executa comandos no jogador
        data.source.runCommand("event entity @s tamanho_normal");
    }
});
world.afterEvents.itemCompleteUse.subscribe((data) => {
    console.warn(`Item completo usado: ${data.itemStack.typeId}`);

    // Verifica se o item consumido é uma poção específica
    if (data.itemStack.typeId === "well:frasco_mana_cheio") {
        // Executa comandos no jogador
        data.source.runCommand("scoreboard players add @s [scores={mana=..100}] mana 100");
		//data.source.runCommand("particle well:orb_evolution");
		//data.source.runCommand("setblock ~ ~ ~ well:luz_orbe");
		data.source.runCommand("playanimation @s animation.humanoid.custom.classe.mago.cajado");
		data.source.runCommand("scoreboard players set @s [scores={mana=100..}] mana 100");
		data.source.runCommand("execute as @s [scores={mana=..100}] run playsound random.drink");
		data.source.runCommand("clear @s [scores={mana=..100}] well:frasco_mana_cheio 0 1");
		data.source.runCommand("function Missoes");
		data.source.runCommand("titleraw @s [scores={mana=100}] actionbar {\"rawtext\":[{\"selector\": \"@s[r=5,c=1]\"}, {\"translate\":\"dialogue.mana.cheia\"}]}");
    }
});

world.afterEvents.itemCompleteUse.subscribe((data) => {
    console.warn(`Item completo usado: ${data.itemStack.typeId}`);

    // Verifica se o item consumido é uma poção específica
    if (data.itemStack.typeId === "well:frasco_mana") {
        // Executa comandos no jogador
        data.source.runCommand("scoreboard players add @s [scores={mana=..100}] mana 10");
		//data.source.runCommand("particle well:orb_evolution");
		//data.source.runCommand("setblock ~ ~ ~ well:luz_orbe");
		data.source.runCommand("playanimation @s animation.humanoid.custom.classe.mago.cajado");
		data.source.runCommand("scoreboard players set @s [scores={mana=100..}] mana 100");
		data.source.runCommand("execute as @s [scores={mana=..100}] run playsound random.drink");
		data.source.runCommand("clear @s [scores={mana=..99}] well:frasco_mana 0 1");
		data.source.runCommand("function Missoes");
		data.source.runCommand("titleraw @s [scores={mana=100}] actionbar {\"rawtext\":[{\"selector\": \"@s[r=5,c=1]\"}, {\"translate\":\"dialogue.mana.cheia\"}]}");
    }
});







const on_Use = [
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "minecraft:milk_bucket",
        code_type: {
            command: {
                commands: [
                    "event entity @s tamanho_normal"
                ],
                subject: commandSubject.Player
            },
            code: (data)=>{
                ////world.sendMessage(data.source.name);
            }
        }
    },
	
	
	
	{
        use_type: useTypes.Item_Use,
        itemID: "well:teleporterapido",
        code_type: {
            command: {
                commands: [
                    "tag @p add contagem_remove_npc",
					"playanimation @s animation.humanoid.custom.classe.mago.cajado"
                ],
                subject: commandSubject.Player
            },
            code: (data)=>{
                ////world.sendMessage(data.source.name);
            }
        }
    },
	
	{
        use_type: useTypes.Item_Use,
        itemID: "well:nectar_frasco",
        code_type: {
            command: {
                commands: [
                    "scoreboard players remove @s [scores={iluminacao_descarga=80..364}] iluminacao_descarga 80",
					"clear @s [scores={iluminacao_descarga=80..}] well:nectar_frasco 0 1",
					"titleraw @s [scores={iluminacao_descarga=..80}] actionbar {\"rawtext\":[{\"selector\": \"@s[r=5,c=1]\"}, {\"translate\":\"dialogue.bateria.cheia\"}]}",
					"tellraw @a [scores={iluminacao_descarga=80..}] {\"rawtext\":[{\"selector\": \"@s[r=5,c=1]\"}, {\"translate\":\"dialogue.bateria.recarregou\"}]}"
                ],
                subject: commandSubject.Player
            },
            code: (data)=>{
                ////world.sendMessage(data.source.name);
            }
        }
    },
	
	{
        use_type: useTypes.Item_Use,
        itemID: "well:fada_no_frasco",
        code_type: {
            command: {
                commands: [
                    "effect @s regeneration 10 5 true",
					"replaceitem entity @s slot.weapon.mainhand 0 minecraft:glass_bottle 1",
					"playsound cura @s",
					"execute as @p [r=5] run particle minecraft:totem_particle ~ ~2 ~",
					"tellraw @a {\"rawtext\":[{\"selector\": \"@s[r=5,c=1]\"}, {\"translate\":\"dialogue.fada_item.msg1\"}]}"
                ],
                subject: commandSubject.Player
            },
            code: (data)=>{
                ////world.sendMessage(data.source.name);
            }
        }
    },
	
	{
        use_type: useTypes.Item_Use,
        itemID: "well:flauta_do_deserto",
        code_type: {
            command: {
                commands: [
                    "summon well:musica ~ ~ ~",
					"playsound Flauta @p ~ ~ ~",
					"dialogue open @e [type=npc:hilda, r=8, c=1] @p [c=1, tag=hero1, r=8] hilda2"
                ],
                subject: commandSubject.Player
            },
            code: (data)=>{
                //world.sendMessage(data.source.name);
            }
        }
    },
	
	{
        use_type: useTypes.Item_Use,
        itemID: "well:mochila_item",
        code_type: {
            command: {
                commands: [
                    "event entity @s well:mochila_domada",
					"clear @s well:mochila_item"
                ],
                subject: commandSubject.Player
            },
            code: (data)=>{
                //world.sendMessage(data.source.name);
            }
        }
    },
	
	{
        use_type: useTypes.Item_Complete_Use,
        itemID: "well:frasco_mana_cheio",
        code_type: {
            command: {
                commands: [
                    "scoreboard players add @s [scores={mana=..100}] mana 100",
					"playanimation @s animation.humanoid.custom.classe.mago.cajado",
					"scoreboard players set @s [scores={mana=100..}] mana 100",
					"execute as @s [scores={mana=..100}] run playsound random.drink",
					"clear @s [scores={mana=..100}] well:frasco_mana_cheio 0 1",
					"function Missoes",
					"titleraw @s [scores={mana=100}] actionbar {\"rawtext\":[{\"selector\": \"@s[r=5,c=1]\"}, {\"translate\":\"dialogue.mana.cheia\"}]}"
                ],
                subject: commandSubject.Player
            },
            code: (data)=>{
                //world.sendMessage(data.source.name);
            }
        }
    },
	
	{
        use_type: useTypes.Item_Complete_Use,
        itemID: "well:frasco_mana",
        code_type: {
            command: {
                commands: [
                    "scoreboard players add @s [scores={mana=..100}] mana 10",
					"playanimation @s animation.humanoid.custom.classe.mago.cajado",
					"scoreboard players set @s [scores={mana=100..}] mana 100",
					"execute as @s [scores={mana=..100}] run playsound random.drink",
					"clear @s [scores={mana=..99}] well:frasco_mana 0 1",
					"function Missoes",
					"titleraw @s [scores={mana=100}] actionbar {\"rawtext\":[{\"selector\": \"@s[r=5,c=1]\"}, {\"translate\":\"dialogue.mana.cheia\"}]}"
                ],
                subject: commandSubject.Player
            },
            code: (data)=>{
                //world.sendMessage(data.source.name);
            }
        }
    },
	
	{
        use_type: useTypes.Item_Use,
        itemID: "well:container_coracao",
        code_type: {
            command: {
                commands: [
                    "scoreboard players add @s container_coracao 1",
					"playanimation @s animation.humanoid.custom.classe.mago.cajado",
					"scoreboard players add @s timer_ui 2",
					"function container",
					"playsound SuperItem @p [scores={container_coracao=..39}] ~ ~ ~ 0.3",
					"scoreboard players set @s [scores={container_coracao=40..}] container_coracao 40",
					"clear @s [scores={container_coracao=2..39}] well:container_coracao 0 1",
					"titleraw @s [scores={container_coracao=2..39}] actionbar {\"rawtext\":[{\"selector\": \"@s[r=5,c=1]\"}, {\"translate\":\"dialogue.acrescentou.container\"}]}"
                ],
                subject: commandSubject.Player
            },
            code: (data)=>{
                //world.sendMessage(data.source.name);
            }
        }
    },
	
	{
        use_type: useTypes.Item_Use,
        itemID: "well:enxada_ruby",
        code_type: {
            command: {
                commands: [
                    "fill ~2 ~-1 ~ ~-1 ~ ~2 farmland [] replace grass",
					"playanimation @s animation.humanoid.custom.classe.mago.cajado",
					"fill ~-2 ~-1 ~ ~-1 ~ ~-2 farmland [] replace grass",
					"fill ~-2 ~-1 ~ ~-1 ~ ~2 farmland [] replace grass",
					"fill ~2 ~-1 ~ ~-1 ~ ~-2 farmland [] replace grass",
					"fill ~2 ~-1 ~ ~-1 ~ ~2 farmland [] replace dirt",
					"fill ~-2 ~-1 ~ ~-1 ~ ~-2 farmland [] replace dirt",
					"fill ~-2 ~-1 ~ ~-1 ~ ~2 farmland [] replace dirt",
					"fill ~2 ~-1 ~ ~-1 ~ ~-2 farmland [] replace dirt"
                ],
                subject: commandSubject.Player
            },
            code: (data)=>{
                //world.sendMessage(data.source.name);
            }
        }
    },
	
	{
        use_type: useTypes.Item_Use,
        itemID: "well:orbe_evolutiva",
        code_type: {
            command: {
                commands: [
				    "playanimation @s animation.humanoid.custom.classe.mago.cajado",
                    "scoreboard players add @s [scores={classe_humana=1}] skill_humana_orbe 1",
					"scoreboard players add @s [scores={classe_elfo=1}] skill_elfo_orbe 1",
					"scoreboard players add @s [scores={classe_mago=1}] skill_mago_orbe 1",
					"playsound Item @s [scores={classe_humana=1}] ~ ~ ~ 0.08",
					"playsound Item @s [scores={classe_elfo=1}] ~ ~ ~ 0.08",
					"playsound Item @s [scores={classe_mago=1}] ~ ~ ~ 0.08",
					"clear @s [scores={skill_mago_orbe=..30}] well:orbe_evolutiva 0 1",
					"clear @s [scores={skill_elfo_orbe=..30}] well:orbe_evolutiva 0 1",
					"clear @s [scores={skill_humana_orbe=..30}] well:orbe_evolutiva 0 1",
					"scoreboard players set @s [scores={skill_mago_orbe=30}] skill_humana_orbe 31",
					"scoreboard players set @s [scores={skill_elfo_orbe=30}] skill_elfo_orbe 31",
					"scoreboard players set @s [scores={skill_humana_orbe=30}] skill_mago_orbe 31",
					"replaceitem entity @s [scores={skill_mago_orbe=5}] slot.hotbar 0 well:cajado_mago2 1 0 {\"item_lock\": {\"mode\": \"lock_in_slot\"}, \"keep_on_death\": {}}",
					"replaceitem entity @s [scores={skill_mago_orbe=10}] slot.hotbar 0 well:cajado_mago3 1 0 {\"item_lock\": {\"mode\": \"lock_in_slot\"}, \"keep_on_death\": {}}",
					"replaceitem entity @s [scores={skill_mago_orbe=20}] slot.hotbar 0 well:cajado_mago4 1 0 {\"item_lock\": {\"mode\": \"lock_in_slot\"}, \"keep_on_death\": {}}",
					"replaceitem entity @s [scores={skill_mago_orbe=30}] slot.hotbar 0 well:cajado_mago5 1 0 {\"item_lock\": {\"mode\": \"lock_in_slot\"}, \"keep_on_death\": {}}",
					"titleraw @s [scores={skill_mago_orbe=5}] title {\"rawtext\":[ {\"translate\":\"dialogue.subiulv.evolucao.2\"}]}",
					"titleraw @s [scores={skill_mago_orbe=10}] title {\"rawtext\":[ {\"translate\":\"dialogue.subiulv.evolucao.3\"}]}",
					"titleraw @s [scores={skill_mago_orbe=20}] title {\"rawtext\":[ {\"translate\":\"dialogue.subiulv.evolucao.4\"}]}",
					"titleraw @s [scores={skill_mago_orbe=30}] title {\"rawtext\":[ {\"translate\":\"dialogue.subiulv.evolucao.5\"}]}",
					"titleraw @s [scores={skill_mago_orbe=5}] subtitle {\"rawtext\":[ {\"translate\":\"dialogue.subiulvsubtitle.evolucao.2\"}]}",
					"titleraw @s [scores={skill_mago_orbe=10}] subtitle {\"rawtext\":[ {\"translate\":\"dialogue.subiulvsubtitle.evolucao.3\"}]}",
					"titleraw @s [scores={skill_mago_orbe=20}] subtitle {\"rawtext\":[ {\"translate\":\"dialogue.subiulvsubtitle.evolucao.4\"}]}",
					"titleraw @s [scores={skill_mago_orbe=30}] subtitle {\"rawtext\":[ {\"translate\":\"dialogue.subiulvsubtitle.evolucao.5\"}]}",
					"execute as @s [scores={skill_mago_orbe=5}] run particle well:lv_up ~ ~ ~",
					"execute as @s [scores={skill_mago_orbe=10}] run particle well:lv_up ~ ~ ~",
					"execute as @s [scores={skill_mago_orbe=20}] run particle well:lv_up ~ ~ ~",
					"execute as @s [scores={skill_mago_orbe=30}] run particle well:lv_up ~ ~ ~",
					"execute as @s [scores={skill_mago_orbe=5}] run playsound missioncomplete @s",
					"execute as @s [scores={skill_mago_orbe=10}] run playsound missioncomplete @s",
					"execute as @s [scores={skill_mago_orbe=20}] run playsound missioncomplete @s",
					"execute as @s [scores={skill_mago_orbe=30}] run playsound missioncomplete @s",
					"titleraw @s [scores={skill_mago_orbe=0..5}] actionbar {\"rawtext\":[ {\"score\":{\"name\": \"@s\", \"objective\": \"skill_mago_orbe\"}}, {\"translate\":\"dialogue.mago.evolucao.2\"}]}",
					"titleraw @s [scores={skill_mago_orbe=6..10}] actionbar {\"rawtext\":[ {\"score\":{\"name\": \"@s\", \"objective\": \"skill_mago_orbe\"}}, {\"translate\":\"dialogue.mago.evolucao.3\"}]}",
					"titleraw @s [scores={skill_mago_orbe=11..20}] actionbar {\"rawtext\":[ {\"score\":{\"name\": \"@s\", \"objective\": \"skill_mago_orbe\"}}, {\"translate\":\"dialogue.mago.evolucao.4\"}]}",
					"titleraw @s [scores={skill_mago_orbe=21..30}] actionbar {\"rawtext\":[ {\"score\":{\"name\": \"@s\", \"objective\": \"skill_mago_orbe\"}}, {\"translate\":\"dialogue.mago.evolucao.5\"}]}"
                ],
                subject: commandSubject.Player
            },
            code: (data)=>{
                //world.sendMessage(data.source.name);
            }
        }
    },
	
	
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "well:pocao_pequeno",
        code_type: {
            command: {
                commands: [
                    "event entity @s pequeno",
					"scoreboard players set @s camera_rpg 4"
                ],
                subject: commandSubject.Player
            },
            code: (data)=>{
                //world.sendMessage(data.source.name);
            }
        }
    },
	
	
    {
        use_type: useTypes.Item_Complete_Use,
        itemID: "well:pocao_gigante",
        code_type: {
            command: {
                commands: [
                    "event entity @s gigante",
					"scoreboard players set @s camera_rpg 5"
                ],
                subject: commandSubject.Player
            },
            code: (data)=>{
                //world.sendMessage(data.source.name);
            }
        }
    },
	
	{
        use_type: useTypes.Item_Use,
        itemID: "well:espada_ruby",
        code_type: {
            command: {
                commands: [
                    "summon well:dano_em_area ^^^4",
					"particle well:dano_area ^^1^4",
					"playsound golpe.area @a [r=5] ~ ~ ~ 0.7",
					"playanimation @s animation.humanoid.ataque.simples.braco"
                ],
                subject: commandSubject.Player
            },
            code: (data)=>{
                //world.sendMessage(data.source.name);
            }
        }
    },
	
	////////////////////////////////////////////////////////
	
	
//	{
//        use_type: useTypes.Item_Use,
//        itemID: "well:espada_humano",
//        code_type: {
//            command: {
//                commands: [
//				    "playanimation @s animation.berserk.combo1",
//                    "effect @s [r=5, scores={mana=1..100}] night_vision 60 5 true",
//					//"scoreboard players remove @s mana 10",
//					
//					
//					"titleraw @s [scores={mana=1..100}] actionbar {\"rawtext\": [{\"translate\": \"mana.10\"}]}",
//					"titleraw @s [scores={mana=..0}] actionbar {\"rawtext\": [{\"translate\": \"dialogue.mana.vazia\"}]}"
//                ],
//                subject: commandSubject.Player
//            },
//            code: (data)=>{
//                //world.sendMessage(data.source.name);
//            }
//        }
//    },
//	
	
	
	
	
	{
        use_type: useTypes.Item_Use,
        itemID: "well:cajado_mago",
        code_type: {
            command: {
                commands: [
				    "playanimation @s animation.humanoid.custom.classe.mago.cajado",
                    "effect @s [r=5, scores={mana=1..100}] night_vision 60 5 true",
					"scoreboard players remove @s mana 10",
					"execute as @s [scores={mana=1..100}] run summon well:circulo_cura ~ ~-0.3 ~",
					"execute as @s [scores={mana=1..100}] run tp @e [type=well:circulo_cura, r=10] @s",
					"titleraw @s [scores={mana=1..100}] actionbar {\"rawtext\": [{\"translate\": \"mana.10\"}]}",
					"titleraw @s [scores={mana=..0}] actionbar {\"rawtext\": [{\"translate\": \"dialogue.mana.vazia\"}]}"
                ],
                subject: commandSubject.Player
            },
            code: (data)=>{
                //world.sendMessage(data.source.name);
            }
        }
    },
	
	{
        use_type: useTypes.Item_Use,
        itemID: "well:cajado_mago2",
        code_type: {
            command: {
                commands: [
				    "playanimation @s animation.humanoid.custom.classe.mago.cajado",
                    "tag @s add mago_executor",
					"tag @e [tag=!mago_executor, type=!well:player_congelado, r=8] add congelado_mob",
					"effect @s [r=5, scores={mana=1..100}] fire_resistance 60 5 true",
					"execute as @s [r=5, scores={mana=1..100}] run particle well:explosao_gelada",
					"execute as @s [r=5, scores={mana=1..100}] run particle minecraft:cauldron_explosion_emitter ~ ~1 ~",
					"execute as @s [r=5, scores={mana=1..100}] run playsound magia.gelo @a [r=10]",
					"scoreboard players remove @s mana 20",
					"execute as @s [r=5, scores={mana=1..100}] at @e [r=5, tag=!mago_executor] run summon well:player_congelado",
					"execute as @s [r=5, scores={mana=1..100}] at @e [r=5, tag=!mago_executor] run particle well:explosao_gelo",
					"titleraw @s [scores={mana=1..100}] actionbar {\"rawtext\": [{\"translate\": \"mana.20\"}]}",
					"titleraw @s [scores={mana=..0}] actionbar {\"rawtext\": [{\"translate\": \"dialogue.mana.vazia\"}]}"
                ],
                subject: commandSubject.Player
            },
            code: (data)=>{
                //world.sendMessage(data.source.name);
            }
        }
    },
	
	{
        use_type: useTypes.Item_Use,
        itemID: "well:cajado_mago4",
        code_type: {
            command: {
                commands: [
				    "playanimation @s animation.humanoid.custom.classe.mago.cajado",
                    "event entity @s use_item_mago4"
                ],
                subject: commandSubject.Player
            },
            code: (data)=>{
                //world.sendMessage(data.source.name);
            }
        }
    },
	
	///////////////////////////////////
	
	{
        use_type: useTypes.Item_Use,
        itemID: "well:cajado_sangue",
        code_type: {
            command: {
                commands: [
				    "playanimation @s animation.humanoid.custom.classe.mago.cajado",
                    "event entity @e [type=well:dragao_sangue, r=3] projectil_dragao",
					"execute at @e [type=well:dragao_sangue, r=3] run playsound mob.enderdragon.growl",
					"execute at @e [type=well:dragao_sangue, r=3] run playanimation @e [type=well:dragao_sangue, r=3] animation.european_dragon.breath",
					"execute at @e [type=well:dragao_sangue, r=3] run effect @e [type=well:dragao_sangue, r=3] slowness 1 20 true",
					"scoreboard players add @e [type=well:dragao_sangue, c=1, r=5] voo_dragao 50"
                ],
                subject: commandSubject.Player
            },
            code: (data)=>{
                //world.sendMessage(data.source.name);
            }
        }
    },
	{
        use_type: useTypes.Item_Use,
        itemID: "well:cajado_almas",
        code_type: {
            command: {
                commands: [
				    "playanimation @s animation.humanoid.custom.classe.mago.cajado",
                    "event entity @e [type=well:dragao_almas, r=5] projectil_dragao",
					"execute at @e [type=well:dragao_almas, r=7] run playsound mob.enderdragon.growl",
					"execute at @e [type=well:dragao_almas, r=5] run playanimation @e [type=well:dragao_almas, r=5] animation.european_dragon.breath",
					"execute at @e [type=well:dragao_almas, r=5] run effect @e [type=well:dragao_almas, r=5] slowness 1 20 true",
					"scoreboard players add @e [type=well:dragao_almas, c=1, r=5] voo_dragao 50"
                ],
                subject: commandSubject.Player
            },
            code: (data)=>{
                //world.sendMessage(data.source.name);
            }
        }
    },
	{
        use_type: useTypes.Item_Use,
        itemID: "well:cajado_gelo",
        code_type: {
            command: {
                commands: [
				    "playanimation @s animation.humanoid.custom.classe.mago.cajado",
                    "event entity @e [type=well:dragao_gelo, r=3] projectil_dragao",
					"execute at @e [type=well:dragao_gelo, r=3] run playsound mob.enderdragon.growl",
					"execute at @e [type=well:dragao_gelo, r=3] run playanimation @e [type=well:dragao_gelo, r=3] animation.european_dragon.breath",
					"execute at @e [type=well:dragao_gelo, r=3] run effect @e [type=well:dragao_gelo, r=3] slowness 1 20 true",
					"scoreboard players add @e [type=well:dragao_gelo, c=1, r=5] voo_dragao 50"
                ],
                subject: commandSubject.Player
            },
            code: (data)=>{
                //world.sendMessage(data.source.name);
            }
        }
    },
	{
        use_type: useTypes.Item_Use,
        itemID: "well:cajado_venenoso",
        code_type: {
            command: {
                commands: [
				    "playanimation @s animation.humanoid.custom.classe.mago.cajado",
                    "event entity @e [type=well:dragao_venenoso, r=3] projectil_dragao",
					"execute at @e [type=well:dragao_venenoso, r=3] run playsound mob.enderdragon.growl",
					"execute at @e [type=well:dragao_venenoso, r=3] run playanimation @e [type=well:dragao_venenoso, r=3] animation.european_dragon.breath",
					"execute at @e [type=well:dragao_venenoso, r=3] run effect @e [type=well:dragao_venenoso, r=3] slowness 1 20 true",
					"scoreboard players add @e [type=well:dragao_venenoso, c=1, r=5] voo_dragao 50"
                ],
                subject: commandSubject.Player
            },
            code: (data)=>{
                //world.sendMessage(data.source.name);
            }
        }
    },
	
	{
        use_type: useTypes.Item_Use,
        itemID: "well:folha_bestiario",
        code_type: {
            command: {
                commands: [
                    "event entity @s use_item"
                ],
                subject: commandSubject.Player
            },
            code: (data)=>{
                //world.sendMessage(data.source.name);
            }
        }
    }
	
	
];
const itemUses = [
    world.afterEvents.itemUse,
    world.afterEvents.itemUseOn,
    world.afterEvents.itemCompleteUse,
    world.afterEvents.itemReleaseUse,
    world.afterEvents.itemStartUse,
    world.afterEvents.itemStartUseOn,
    world.afterEvents.itemStopUse,
    world.afterEvents.itemStopUseOn
];
const itemUsesTypes = [
    useTypes.Item_Use,
    useTypes.Item_Use_On,
    useTypes.Item_Complete_Use,
    useTypes.Item_Release_Use,
    useTypes.Item_Start_Use,
    useTypes.Item_Start_Use_On,
    useTypes.Item_Stop_Use,
    useTypes.Item_Stop_Use_On
];
world.afterEvents.worldLoad.subscribe(() => {
for(let i = 0; i < itemUses.length; i++){
    const itemUse = itemUses[i];
    itemUse.subscribe((data)=>{
        const Data = data;
        const code = on_Use.find((f)=>f.use_type == itemUsesTypes[i] && f.itemID == Data.itemStack.typeId);
        if (code == undefined) return;
        const component = Data.itemStack.getComponent(ItemCooldownComponent.componentId);
        if (component?.getCooldownTicksRemaining(Data.source) >= 1 && component?.getCooldownTicksRemaining(Data.source) <= component?.cooldownTicks - 2) return;
        if (component) component.startCooldown(Data.source);
        const command = code.code_type.command;
        const func = code.code_type.code;
        if (func != undefined) {
            func(Data);
        }
        if (command != undefined) {
            let subject = Data.source;
            if (command.subject == commandSubject.Dimension) subject = Data.source.dimension;
            for (const cmd of command.commands){
                subject.runCommand(cmd);
            }
        }
    });
}
});