import * as ui from "@minecraft/server-ui";
import { ActionFormData,  MessageFormData,  ModalFormData} from "@minecraft/server-ui";
import { world, system, Player, MolangVariableMap, Entity} from "@minecraft/server";
//const overworld = world.getDimension('minecraft:overworld');

function getScoreMontaria(player, montariaObjective) {
    const { scoreboardIdentity } = player;
    if (!(player instanceof Player)) return 0;
    try {
        return world.scoreboard.getObjective(montariaObjective).getScore(scoreboardIdentity);
    } catch (e) {
        return 0;
    }
}


function getScoreMana(player, manaObjective) {
    const { scoreboardIdentity } = player;
    if (!(player instanceof Player)) return 0;
    try {
        return world.scoreboard.getObjective(manaObjective).getScore(scoreboardIdentity);
    } catch (e) {
        return 0;
    }
}

world.afterEvents.itemUse.subscribe(async (event) => {
    const { itemStack, source } = event;
    if (itemStack.typeId !== 'well:cajado_mago3') return;

    // Obtém o valor do scoreboard 'mana' usando a função getScoreMana
    const manaValue = getScoreMana(source, 'mana');

    // Verifica se o valor de 'mana' está abaixo de 30
    if (manaValue < 30) {
        // Executa o comando para mostrar a mensagem de mana vazia
        await source.runCommand('titleraw @s actionbar {\"rawtext\": [{\"translate\": \"dialogue.mana.vazia\"}]}');
        return; // Encerra a execução do código
    }

    // Checa se o valor de 'mana' está entre 30 e 100
    if (manaValue > 100) return;

    const viewDir = source.getViewDirection();
    const fireBall = source.dimension.spawnEntity("well:bola_raio2", source.getHeadLocation());
    const projectile = fireBall.getComponent("projectile");
    projectile.owner = source;
    projectile.shoot(viewDir);

    // Adiciona a linha para o jogador executar um comando
	await source.runCommand('playanimation @s animation.humanoid.custom.classe.mago.cajado');
    await source.runCommand('scoreboard players remove @s mana 10');
    await source.runCommand('playsound magia.choque');
    await source.runCommand('effect @s darkness 2 1 true');
    await source.runCommand('titleraw @s actionbar {\"rawtext\": [{\"translate\": \"mana.10\"}]}');
    
});

world.afterEvents.itemUse.subscribe(async (event) => {
    const { itemStack, source } = event;
    if (itemStack.typeId !== 'well:cajado_mago5') return;

    // Obtém o valor do scoreboard 'mana' usando a função getScoreMana
    const manaValue = getScoreMana(source, 'mana');

    // Verifica se o valor de 'mana' está abaixo de 30
    if (manaValue < 10) {
        // Executa o comando para mostrar a mensagem de mana vazia
        await source.runCommand('titleraw @s actionbar {\"rawtext\": [{\"translate\": \"dialogue.mana.vazia\"}]}');
        return; // Encerra a execução do código
    }

    // Checa se o valor de 'mana' está entre 30 e 100
    if (manaValue > 100) return;

    const viewDir = source.getViewDirection();
    const fireBall = source.dimension.spawnEntity("well:bola_sol", source.getHeadLocation());
    const projectile = fireBall.getComponent("projectile");
    projectile.owner = source;
    projectile.shoot(viewDir);

    // Adiciona a linha para o jogador executar um comando
	await source.runCommand('playanimation @s animation.humanoid.custom.classe.mago.cajado');
    await source.runCommand('scoreboard players remove @s mana 10');
    await source.runCommand('playsound mob.ghast.fireball');
    await source.runCommand('titleraw @s actionbar {\"rawtext\": [{\"translate\": \"mana.10\"}]}');
    
});


